//
//  BitsDisplay.m
//  HP41
//
//  Created by greg on Wed Aug 13 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "BitsDisplay.h"

@implementation BitsDisplay

- (void) attachTo: (int *) reg bits: (int) nBits {
    self->bits = reg;
    self->numBits = nBits;
}

- (int) numColumns {
    return (self->numBits + 3) >> 2;
}

//- (Digit) getDigit: (int) index ofLine: (int) line {
//    return (*self->bits >> (index << 2)) & 0xf;
//}

- (BOOL) getDigitsForLine: (int) line into: (Digits_14) data {
    int i = 0;
    int word = *self->bits;
    while (i < self->numBits) {
        data[i++] = word & 0xF;
        word >>= 4;
    }
    return YES;
}

- (void) setDigit: (int) index ofLine: (int) line to: (int) digit {
    int limitMask = (1 << self->numBits) - 1;
    int digitShift = index << 2;
    int digitMask = 0xF << digitShift;
    int newBits = (*self->bits & ~digitMask) | (digit << digitShift);
    *self->bits = newBits & limitMask;
}

- (void) drawBackground {
    if (*self->bits & ~((1 << self->numBits) - 1)) {
        [[NSColor redColor] set];
        NSRectFill([self bounds]);
    }
    else
        [super drawBackground];
}

@end
