#import <stdio.h>
#import "Key.h"
#import "Keyboard.h"
#import "KeyGroup.h"

@implementation KeyGroup

- (id) initWithFrame: (NSRect) frameRect
{
	[super initWithFrame:frameRect];
	return self;
}

- (void) drawRect: (NSRect)rect
{
}

//- (void) setKeyboard: (Keyboard *) kbd {
//    self->keyboard = kbd;
//}

//- (void) setKeyMap: (struct KeyMap *) map {
//    self->keyMap = map;
//}

// During initialisation, we use the position of each key
// relative to us to find an entry in our key map, and
// set its key code accordingly.

- (void) registerKey: (Key *) key {
    struct KeyMap *map = [self->keyboard keyMapForGroup: self];
    if (map) {
        NSPoint p = [key frame].origin;
        NSSize s = [self bounds].size;
        int col = map->numCols * p.x / s.width;
        int row = (map->numRows - 1) - (int)(map->numRows * p.y / s.height);
        [key setKeyCode: map->keyCodes[row][col]];
        [self->keyboard registerKey: key withCode: [key keyCode]];
    }
}

// When one of our keys is pressed or released, we use its position
// relative to us to find an entry in our key map, and send an 
// appropriate message to the Keyboard.

- (void) key: (Key *) key pressed: (BOOL) pressed {
    //NSPoint p = [key frame].origin;
    //NSSize s = [self bounds].size;
    //struct KeyMap *map = self->keyMap;
    //int col = map->numCols * p.x / s.width;
    //int row = (map->numRows - 1) - (int)(map->numRows * p.y / s.height);
    //printf("[KeyGroup key:pressed:] row = %d, col = %d, pressed = %d\n",
    //    row, col, pressed);
    //int code = map->keyCodes[row][col];
    int code = [key keyCode];
    [self->keyboard keyWithCode: code pressed: pressed];
}

- (BOOL) acceptsFirstMouse: (NSEvent *) event {
    return YES;
}

@end
