/* Keyboard */

#import <Cocoa/Cocoa.h>

@class Key;
@class KeyGroup;
@class Rocker;
@protocol CPU_KbdInterface;

@interface Keyboard : NSResponder
{
    IBOutlet KeyGroup *arithmeticGroup;
    IBOutlet KeyGroup *functionGroup;
    IBOutlet KeyGroup *numberGroup;
    IBOutlet Rocker *on_user_rocker;
    IBOutlet Rocker *prgm_alpha_rocker;
    IBOutlet id <CPU_KbdInterface> cpu;
}

- (struct KeyMap *) keyMapForGroup: (KeyGroup *) group;
- (void) registerKey: (id) key withCode: (int) code;
- (void) keyWithCode: (int) code pressed: (BOOL) pressed;
- (void) keyEvent: (NSEvent *) event down: (BOOL) down;

@end
