//
//  ModeDisplay.m
//  HP41
//
//  Created by greg on Sat Aug 16 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "ModeDisplay.h"


@implementation ModeDisplay

- (void) attachTo: (int *) bits withValues: (char *) chars {
    self->data = bits;
    self->characters = chars;
}

- (BOOL) acceptsFirstResponder {
    return YES;
}

- (BOOL) becomeFirstResponder {
    self->isSelected = YES;
    [self setNeedsDisplay: YES];
    return YES;
}

- (BOOL) resignFirstResponder {
    if (self->isSelected) {
        self->isSelected = NO;
        [self setNeedsDisplay: YES];
    }
    return YES;
}

- (void) mouseDown: (NSEvent *) event {
    self->isSelected = YES;
    [self setNeedsDisplay: YES];
}

- (void) keyDown: (NSEvent *) event {
    if (self->isSelected) {
        NSString *s = [[event characters] uppercaseString];
        unichar c = [s characterAtIndex: 0];
        printf("ModeDisplay keyDown: 0x%04x\n", c);
        switch (c) {
            case 0x9:
                [super keyDown: event];
                break;
            case 0x3:
            case 0xd:
                [self resignFirstResponder];
                break;
            default: {
                char *p = index(self->characters, c);
                if (p) {
                    *self->data = p - self->characters;
                    [self setNeedsDisplay: YES];
                }
            }
        }
    }
}

- (void) drawRect: (NSRect) rect {
    NSRect bounds = [self bounds];
    NSDictionary *attrs;
    int value = *self->data;
    char c;
    if (value < strlen(self->characters))
        c = self->characters[value];
    else
        c = '?';
    if (self->isSelected) {
        [self->foregroundColor set];
        attrs = self->reverseAttributes;
    }
    else if (c == '?') {
        [[NSColor redColor] set];
        attrs = self->reverseAttributes;
    }
    else {
        [self->backgroundColor set];
        attrs = self->attributes;
    }
    NSRectFill(bounds);
    NSString *s = [NSString stringWithFormat: @"%c", c];
    float x = (bounds.size.width - self->digitSize.width) / 2;
    //float y = (bounds.size.height - self->digitSize.height) / 2;
    float y = 0;
    [s drawAtPoint: NSMakePoint(x, y) withAttributes: attrs];
}

@end
