// Protocol for I/O devices that can be plugged into the bus.

#import "DataTypes.h"

@class Bus;

@protocol Peripheral <NSObject>

- (void) pluggedIntoBus: (Bus *) bus;
- (void) readFromRegister: (Bits_4) reg into: (Digits_14) data;
- (void) writeToRegister: (Bits_4) reg from: (Digits_14) data;
- (void) writeDataFrom: (Digits_14) data;

@end
