//
//  RSelectDisplay.m
//  HP41
//
//  Created by greg on Fri Aug 15 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "RSelectDisplay.h"


@implementation RSelectDisplay

- (void) attachTo: (int *) bit {
    self->rSelectBit = bit;
}

- (BOOL) acceptsFirstResponder {
    return YES;
}

- (BOOL) becomeFirstResponder {
    self->isSelected = YES;
    [self setNeedsDisplay: YES];
    return YES;
}

- (BOOL) resignFirstResponder {
    if (self->isSelected) {
        self->isSelected = NO;
        [self setNeedsDisplay: YES];
    }
    return YES;
}

- (void) mouseDown: (NSEvent *) event {
    self->isSelected = YES;
    [self setNeedsDisplay: YES];
}

- (void) keyDown: (NSEvent *) event {
    if (self->isSelected) {
        NSString *s = [[event characters] uppercaseString];
        unichar c = [s characterAtIndex: 0];
        printf("RSelectDisplay keyDown: 0x%04x\n", c);
        switch (c) {
            case 0x9:
                [super keyDown: event];
                break;
            case 0x3:
            case 0xd:
                [self resignFirstResponder];
                break;
            case 'P':
            case 'Q':
                *self->rSelectBit = c - 'P';
                [self setNeedsDisplay: YES];
                break;
        }
    }
}

- (void) drawRect: (NSRect) rect {
    NSRect bounds = [self bounds];
    NSDictionary *attrs;
    if (self->isSelected) {
        [self->foregroundColor set];
        attrs = self->reverseAttributes;
    }
    else {
        [self->backgroundColor set];
        attrs = self->attributes;
    }
    NSRectFill(bounds);
    NSString *s = [NSString stringWithFormat: @"%c", "PQ"[*self->rSelectBit]];
    float x = (bounds.size.width - self->digitSize.width) / 2;
    //float y = (bounds.size.height - self->digitSize.height) / 2;
    float y = 0;
    [s drawAtPoint: NSMakePoint(x, y) withAttributes: attrs];
}

@end
